#pragma once
#include <fstream>
#include "Exception.h"
#include <vector>
#include <algorithm>
#include <iterator>

void createData(const std::string&);
void createDataContainer(const std::string&);

template <class T>
class Data {
private:
	std::vector<T> cont;
public:

	Data() {
		std::vector<T> v;
		cont = std::move(v);
	}

	Data(int size) {
		std::vector<T> v(size);
		cont = std::move(v);
	}

	std::vector<T> loadData(const std::string& filepath) {
		std::ifstream file(filepath + ".txt");
		if (!file)
			throw FileException(1);
		T a;
		for (; !file.eof(); file >> a) {
			cont.push_back(a);
		}
		return cont;
	}

	std::vector<T> streamloadData(const std::string& filepath) {
		std::ifstream file(filepath + ".txt");
		std::copy(std::istream_iterator<T>(file), std::istream_iterator<T>(), std::back_inserter(cont));
		return cont;
	}

	void modify() {
		int count = 0;
		T S = 0;

		for (auto i = cont.begin(); i != cont.end(); ++i)
			S += *i;

		T m = S / cont.size();
		for (auto i = cont.begin(); i != cont.end(); ++i) {
			if (*i > 0) {
				++count;
				if (count == 3) {
					count = 0;
					*i = m;
				}
			}
		}
	}

	static void modify(typename std::vector<T>::iterator a, typename std::vector<T>::iterator b) {
		int count = 0;
		T S = 0;

		for (auto i = a; i != b; ++i) {
			S += *i;
			++count;
		}

		T m = S / count;
		count = 0;
		for (auto i = a; i != b; ++i) {
			if (*i > 0) {
				++count;
				if (count == 3) {
					count = 0;
					*i = m;
				}
			}
		}
	}

	void modify_for_each() {
		T S = 0;

		for (auto i = cont.begin(); i != cont.end(); ++i)
			S += *i;

		T m = S / cont.size();

		auto f = [m](T& x) {
			static int count = 0;
			if (x > 0) {
				++count;
				if (count == 3) {
					count = 0;
					x = m;
				}
			}
		};

		std::for_each(cont.begin(), cont.end(), f);
	}

	void outputResult(const std::string& filepath) {
		std::ofstream file(filepath + ".txt");
		if (!file)
			throw FileException(1);
		for (auto i = cont.begin(); i != cont.end(); ++i)
			file << *i << " ";
	}

	void outputResultContainer(const std::string& filepath) {
		std::ofstream file(filepath + ".txt");
		if (!file)
			throw FileException(1);
		std::copy(cont.begin(), cont.end(), std::ostream_iterator<int>(file, " "));
	}

};