#include "TravelCompany.h"

std::ostream& operator << (std::ostream& out, const TravelCompany& data) {
	for (auto i = data.cont.begin(); i != data.cont.end(); ++i) {
		out << i->tour_name << " " <<
			i->surname << " " <<
			i->price << " " <<
			i->days << " " <<
			i->moving_cost << " " <<
			i->exchange_rate << " " <<
			i->amount << " " <<
			i->travel_cost << " " << std::endl;
	}
	return out;
}

std::istream& operator >> (std::istream& in, TravelCompany& data) {
	while (true) {
		TravelCompany::Data d;
		in >> d.tour_name;
		in >> d.surname;
		in >> d.price;
		in >> d.days;
		in >> d.moving_cost;
		in >> d.exchange_rate;
		in >> d.amount;
		in >> d.travel_cost;
		if (d == TravelCompany::Data())
			break;
		else
			data.cont.insert(d);
	}
	return in;
}

bool TravelCompany::operator == (const TravelCompany& data) {
	if (cont.size() != data.cont.size())
		return false;
	auto i = cont.begin();
	auto j = data.cont.begin();
	while (i != cont.end() && j != data.cont.end()) {
		if (const_cast<TravelCompany::Data&>(*i) != const_cast<TravelCompany::Data&>(*j))
			return false;
		++i;
		++j;
	}
	return true;
}

void TravelCompany::create_file(const std::string& filepath) {
	std::ofstream file(filepath + ".bin");
	if (!file)
		throw FileException(1);
	while (true) {
		std::cin >> *this;
		if (*this == TravelCompany())
			break;
		else
			file << *this;
	}
}

void TravelCompany::add(const std::string& filepath) {
	std::ofstream file(filepath + ".bin");
	if (!file)
		throw FileException(1);
	for (auto i = cont.begin(); i != cont.end(); ++i) {
		file.write(i->tour_name.c_str(), strlen(i->tour_name.c_str()));
		file.write(i->surname.c_str(), strlen(i->surname.c_str()));
		file.write(reinterpret_cast<const char*>(&i->price), sizeof(i->price));
		file.write(reinterpret_cast<const char*>(&i->days), sizeof(i->days));
		file.write(reinterpret_cast<const char*>(&i->moving_cost), sizeof(i->moving_cost));
		file.write(reinterpret_cast<const char*>(&i->exchange_rate), sizeof(i->exchange_rate));
		file.write(reinterpret_cast<const char*>(&i->amount), sizeof(i->amount));
		file.write(reinterpret_cast<const char*>(&i->travel_cost), sizeof(i->travel_cost));
	}
}

void TravelCompany::delete_data(const std::string& filepath) {
	std::ifstream file(filepath + ".bin");
	if (!file)
		throw FileException(1);
	while (!file.eof()) {
		TravelCompany data;
		for (auto i = data.cont.begin(); i != data.cont.end(); ++i) {
			file.read(const_cast<char*>(reinterpret_cast<const char*>(&i->tour_name)), sizeof(i->tour_name));
			file.read(const_cast<char*>(reinterpret_cast<const char*>(&i->surname)), sizeof(i->surname));
			file.read(const_cast<char*>(reinterpret_cast<const char*>(&i->price)), sizeof(i->price));
			file.read(const_cast<char*>(reinterpret_cast<const char*>(&i->days)), sizeof(i->days));
			file.read(const_cast<char*>(reinterpret_cast<const char*>(&i->moving_cost)), sizeof(i->moving_cost));
			file.read(const_cast<char*>(reinterpret_cast<const char*>(&i->exchange_rate)), sizeof(i->exchange_rate));
			file.read(const_cast<char*>(reinterpret_cast<const char*>(&i->amount)), sizeof(i->amount));
			file.read(const_cast<char*>(reinterpret_cast<const char*>(&i->travel_cost)), sizeof(i->travel_cost));
			if (!const_cast<Data&>(*i).in(data.cont))
				data.add(filepath + " 2");
		}
	}

	remove((filepath + ".bin").c_str());
	if (rename((filepath + " 2.bin").c_str(), (filepath + ".bin").c_str()) != 0)
		throw FileException(2);
}

void TravelCompany::replacement(const std::string& filepath, TravelCompany& data) {
	this->delete_data(filepath);
	data.add(filepath);
}
